#include <jni.h>
#include "uacalc_Compute.h"
#include <stdio.h>
#define EXTERN extern
#include "includes.h"

static jclass ProgressClass = 0;
static jmethodID ResultLogAppendId = 0;
static jmethodID ProgressLogAppendId = 0;
JNIEnv *JNICurrentEnv;
//Always points to the last environment,
//you have to set this on each entry into native code
//for the Log functions below to work!

JNIEXPORT jint JNICALL JNI_OnLoad
(JavaVM *vm, void *reserved) {

    JNIEnv* env = 0;
    jclass cls;
    
    if (JNI_OK != (*vm)->GetEnv(vm, (void **)&env, 
				JNI_VERSION_1_2)) {
	return JNI_ERR;
    }
    cls = (*env)->FindClass(env, "uacalc/Progress");
    if (!cls) return JNI_ERR;
    ProgressClass = (*env)->NewGlobalRef(env, cls);

    ResultLogAppendId = (*env)->GetStaticMethodID(
	env, ProgressClass, "ResultLogAppend",
	"(Ljava/lang/String;)V");
    if (!ResultLogAppendId) return JNI_ERR;

    ProgressLogAppendId = (*env)->GetStaticMethodID(
	env, ProgressClass, "ProgressLogAppend",
	"(Ljava/lang/String;)V");
    if (!ProgressLogAppendId) return JNI_ERR;

    return JNI_VERSION_1_2;
}

void C_ResultLogAppend(char *s) {

    (*JNICurrentEnv)->CallStaticVoidMethod(
	JNICurrentEnv, ProgressClass, ResultLogAppendId,
	(*JNICurrentEnv)->NewStringUTF(JNICurrentEnv, s));
}


void C_ProgressLogAppend(char *s) {
    (*JNICurrentEnv)->CallStaticVoidMethod(
	JNICurrentEnv, ProgressClass, ProgressLogAppendId,
	(*JNICurrentEnv)->NewStringUTF(JNICurrentEnv, s));
}

JNIEXPORT void JNICALL Java_uacalc_Compute_run_1uab
(JNIEnv *env, jclass cls, jstring project, jint level) {

    const char *str = (*env)->GetStringUTFChars(env, project, 0);

    JNICurrentEnv = env;
    GUI_mode = YES;
    StopIt = NO;

    log_level_limit=level;
    do_it(str);
    (*env)->ReleaseStringUTFChars(env, project, str);
} 

JNIEXPORT void JNICALL Java_uacalc_Compute_stop_1uab
(JNIEnv *env, jclass cls) {

    StopIt = YES;

}

