package javamath.hasse.lattice;


import javamath.hasse.util.LinkedList;
import java.util.*;

public class POElem {
  OrderedSet poset;
  String label;
  double x, y;		// x and y coords for the diagram
  // All of these should be linked lists
  Vector upperCovers;
  Vector lowerCovers;
  Vector ideal;
  Vector filter;
  // Elements of poset incomparable with `this' and
  // which come after it in the linear order of poset.
  LinkedList highIncomparables; 
  int rank;

  public POElem(String label) {
    this.label = label;
  }

  public String label() {
    return label;
  }

  public String toString() {
    return label;
  }

  public Vector upperCovers() {
    return upperCovers;
  }

  public Vector lowerCovers() {
    return lowerCovers;
  }

  public double xCoord() {
    return x;
  }

  public double yCoord() {
    return y;
  }

  public OrderedSet orderedSet() {
    return poset;
  }

  public Vector filter() {
    return filter;
  }

  public Vector ideal() {
    return ideal;
  }

  public LinkedList highIncomparables() {
    return highIncomparables;
  }

  public int rank() {
    return rank;
  }

}

