package javamath.hasse.util;
/* QuickSort.java	96/6/26 

An abstract class for quicksort. Uses the middle element for the pivot
which means it works well on sets that are already nearly sorted.

*/


import java.lang.*;
import java.util.*;

public abstract class QuickSort {

  Vector v;

  public QuickSort(Vector v) {
    this.v = v;
    sort();
  }

  void sort() {
    sort_aux(0, v.size() - 1);
  }

  void sort_aux(int head, int tail) {
//System.out.println("Enter sort_aux, head = " + head + " tail = " + tail);
    if (head < tail) {
      int pivotIndex = (head + tail)/2;
      Object pivot = v.elementAt(pivotIndex);
      int i = head - 1;
      int j = tail + 1;
      do {
        do i++; while (! leq(pivot, v.elementAt(i)));
        do j--; while (! leq(v.elementAt(j),pivot));
        if (i < j) swap(i, j);
      } while (i < j);
      if (i == j) {
        sort_aux(head, j - 1);
        sort_aux(i + 1, tail);
      } else {
        sort_aux(head, j);
        sort_aux(i, tail);
      }
    }
  }


  public abstract boolean leq (Object a, Object b);
  public abstract boolean lt (Object a, Object b);

  void swap (int i, int j) {
//System.out.println("Swapping i = " + i + " j = " + j);
//System.out.println("v before: " + v);
    Object obj = v.elementAt(i);
    v.setElementAt(v.elementAt(j), i);
    v.setElementAt(obj, j);
//System.out.println("v after:  " + v);
  }

/*
  public static void main(String[] args) {
    Vector v = new Vector();
    v.addElement(new Integer(2));
    v.addElement(new Integer(1));
    v.addElement(new Integer(8));
//    v.addElement(new Integer(5));
    v.addElement(new Integer(5));
    v.addElement(new Integer(9));
    v.addElement(new Integer(6));
    v.addElement(new Integer(5));
    System.out.println("" + v);
    new QuickSortTest(v);
    System.out.println("" + v);
  }

*/

}

/*

class QuickSortTest extends QuickSort {

  public QuickSortTest(Vector v) {
    super(v);
  }

  boolean leq(Object a, Object b) {
    return ((Integer)a).intValue() <= ((Integer)b).intValue();
  }

  boolean lt(Object a, Object b) {
    return ((Integer)a).intValue() < ((Integer)b).intValue();
  }
}

*/
