package uacalc.alg.algedit;

import uacalc.alg.Algebra;
import uacalc.config.Configure;

import java.awt.*;
import java.io.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public class AlgebraDisplayerPane {

    public AlgebraDisplayerPane(JPanel leftPane,
				JPanel rightPane ) {
	
	m_A = null;

//Name of algebra
        AlgebraNameTextLabel = new JLabel(
            "Name of the algebra:");
        Configure.setupLabel(AlgebraNameTextLabel);
        leftPane.add(AlgebraNameTextLabel);
 
        AlgebraNameValueLabel = new JLabel("None");
        Configure.setupLabel(AlgebraNameValueLabel);
        rightPane.add(AlgebraNameValueLabel);
 
//Size of algebra
        AlgebraSizeTextLabel = new JLabel(
            "Number of elements:");
        Configure.setupLabel(AlgebraSizeTextLabel);
        leftPane.add(AlgebraSizeTextLabel);
 
        AlgebraSizeValueLabel = new JLabel("Undefined");
        Configure.setupLabel(AlgebraSizeValueLabel);
        rightPane.add(AlgebraSizeValueLabel);
 
//Number of operations
        NumOpTextLabel = new JLabel(
            "Number of operations:");
        Configure.setupLabel(NumOpTextLabel);
        leftPane.add(NumOpTextLabel);
 
        NumOpValueLabel = new JLabel("Undefined");
        Configure.setupLabel(NumOpValueLabel);
        rightPane.add(NumOpValueLabel);    

    }

    public void setAlgebra(Algebra A) {
	m_A = A;
	AlgebraNameValueLabel.setText(A.getName());
        AlgebraNameValueLabel.setMaximumSize(
            AlgebraNameValueLabel.getPreferredSize());
	AlgebraSizeValueLabel.setText("" + A.getSize());
        AlgebraSizeValueLabel.setMaximumSize(
            AlgebraSizeValueLabel.getPreferredSize());
	NumOpValueLabel.setText("" + A.getNumOp());
        AlgebraSizeValueLabel.setMaximumSize(
            AlgebraSizeValueLabel.getPreferredSize());
    }


//Components
    private JLabel AlgebraNameTextLabel;
    private JLabel AlgebraNameValueLabel;
    private JLabel AlgebraSizeTextLabel;
    private JLabel AlgebraSizeValueLabel;
    private JLabel NumOpTextLabel;
    private JLabel NumOpValueLabel;

    private Algebra m_A;

}

