package uacalc.alg.algedit;

import uacalc.alg.Algebra;
import uacalc.alg.Operation;
import uacalc.config.Configure;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

class OpListTable extends JScrollPane {

    public OpListTable() {

	m_NumOp = 0;
	textArea = new JTextArea();

	textArea.setEditable(false);
	setViewportView(textArea);
	MaxScrollDim = new Dimension();
    }

    public void write(Algebra A) {
//This is the simplest way. We could define functions like
//delete operation and add operation, but this is not
//time critical, so we always rewrite the entire table instead.

	//Delete all the text
	textArea.replaceRange(null, 0, textArea.getDocument().getLength());

        int i;
        Operation f;
	m_NumOp = A.getNumOp();
        for( i=0; i< m_NumOp; i++) {
            f = A.getOp(i);
            textArea.append(" " + f.getNameString() + " has arity " +
                          f.getArity() + " ");
	    if(i < m_NumOp-1) textArea.append("\n");
        }
	setMaxScrollDimension(m_NumOp);
    }

    private void setMaxScrollDimension(int n) {
        //Calculate and set the maximum size of scrollPane
        //assuming that there are n operations on the list.
 
	textArea.setRows(n);
	int w = (int)getPreferredSize().getWidth();
        int h = (int)textArea.getPreferredScrollableViewportSize().getHeight();
        w += (int)getVerticalScrollBar().getMinimumSize().getWidth();
        h += (int)getHorizontalScrollBar().getMinimumSize().getHeight();
     //This must be a bug in JAVA:
     //if we let w and h be doubles rather than integers,
     //then the list will not appear on the screen!
        MaxScrollDim.setSize(w, h);
        setMaximumSize(MaxScrollDim);
	if (n > Configure.DEFAULT_NUMBER_OF_VISIBLE_OPERATIONS) {
	    textArea.setRows(Configure.DEFAULT_NUMBER_OF_VISIBLE_OPERATIONS);
	}
    }

    private JTextArea textArea;
    private Dimension MaxScrollDim;
    private int m_NumOp;

}
