package uacalc.alg.con.ui;

import uacalc.util.Project;

import java.awt.*;
import java.io.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;
import javamath.hasse.latdraw.*;

public class LatticeDisplayer2 extends Frame {

/*
  public boolean handleEvent(Event e) {
    switch (e.id) {
      case Event.WINDOW_DESTROY:
        System.exit(0);
        return true;
      case Event.ACTION_EVENT:
        if (e.target instanceof MenuItem) {
          if (((String)e.arg).equals("Quit")) {
            System.exit(0);
            return true;
          }
        }
      default:
        return false;
    }
  }
*/


    private CongruenceLatticeDisplayer m_displayer;
    private LatDrawWin latdrawwin;
  //private JMenuItem CloseMenuItem;


  public LatticeDisplayer2(CongruenceLatticeDisplayer displayer,
			   Project proj) {

      m_displayer = displayer;

    //Set up menus
    MenuBar menubar = new MenuBar();
    setMenuBar(menubar);
    Menu file = new Menu("File");
    //file.add(new MenuItem("Open"));
    MenuItem closeItem = new MenuItem("Close");
    //file.add(new MenuItem("Quit"));
    file.add(closeItem);
    menubar.add(file);
    //Menu help = new Menu("Help");
    //help.add(new MenuItem("About"));
    //menubar.add(help);
    //menubar.setHelpMenu(help);

    closeItem.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            OnClose();
        }
      });

    Menu help = new Menu("Help");
    MenuItem tipItem = new MenuItem("Tips");
    help.add(tipItem);
    menubar.add(help);

    tipItem.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            OnHelp();
        }
      });


/*
    JMenuBar menuBar;
    JMenuItem menuItem;

    menuBar = new JMenuBar();
    setJMenuBar(menuBar);

//File menu
    JMenu FileMenu = new JMenu("File");
    FileMenu.setMnemonic(KeyEvent.VK_F);
    menuBar.add(FileMenu);

//Close
    CloseMenuItem = new JMenuItem("Close", KeyEvent.VK_C);
    FileMenu.add(CloseMenuItem);
    CloseMenuItem.setAccelerator(
        KeyStroke.getKeyStroke(KeyEvent.VK_C, ActionEvent.CTRL_MASK));

    CloseMenuItem.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            OnClose();
        }
      });
*/
//Set up window components

    latdrawwin = new LatDrawWin();
    latdrawwin.setStandalone(true);
    latdrawwin.setIncludeExampleLattices(false);
    latdrawwin.setFile(proj.getName(Project.ConHasseType));
    //if (args.length != 0) latdrawwin.file = args[0];
    latdrawwin.init();
    latdrawwin.start();
    
    add(latdrawwin);

    //setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
          OnClose();
        }
      });

    pack();

    setTitle("Lattice Drawer");
    //parent.setEnabled(false);
    setSize(500, 650);             // Emil change this to what you like.
    setVisible(true);
  }

  public void OnClose() {
    if( !isEnabled() ) return;
    m_displayer.disposeDrawer();
  }

  public void OnHelp() {
      //I do not want to start to learn how to set up dialogs
      //In the present environment, so temporarily I write to
      //System.out.
      System.out.println(
	  "Right click on a vertex to get information on the corresponding partition.");
      System.out.println(
	  "Right click on an edge to get information on the corresponding cover.");
      System.out.println("These are shown in the Congruence Viewer window.");
  }


/*
  public String getElementAt(int x, int y) {
    return latdrawwin.getElementAt(x, y);
  }
*/

  /**
   * Add property listeners.
   */
  public void addPropertyChangeListener(PropertyChangeListener l) {
    latdrawwin.addPropertyChangeListener(l);
  }

  /**
   * Remove property listeners.
   */
  public void removePropertyChangeListener(PropertyChangeListener l) {
    latdrawwin.removePropertyChangeListener(l);
  }

  /**
   * Set the TCT color mapping. The keys of <code>ht</code> should be
   * the strings "1" to "5".
   */
  public void setTCTColorMap(Hashtable ht) {
    latdrawwin.setEdgeColorMap(ht);
  }

  public void setTCTColorMap(
      Color type1Color,
      Color type2Color,
      Color type3Color,
      Color type4Color,
      Color type5Color ) {

      Hashtable edgeColorMap = new Hashtable(5);
      edgeColorMap.put("1", type1Color);
      edgeColorMap.put("2", type2Color);
      edgeColorMap.put("3", type3Color);
      edgeColorMap.put("4", type4Color);
      edgeColorMap.put("5", type5Color); 
      setTCTColorMap( edgeColorMap );
  }

  public void setBackgroundColor(Color c) {
    latdrawwin.setBackgroundColor(c);
  }

  /**
   * Add an edge to the highlighted edges. 
   * @param edge a String[] with the two labels.
   */
  public void addHighlightedEdge(String[] edge) {
    Vector v = new Vector(2);
    v.add(edge[0]);
    v.add(edge[1]);
    latdrawwin.addHighlightedEdge(v);
  }

  /**
   * Add an edge to the highlighted edges. 
   * @param edge a vector with the two String labels.
   */
  public void addHighlightedEdge(Vector edge) {
    latdrawwin.addHighlightedEdge(edge);
  }

  /**
   * Remove an edge to the highlighted edges. 
   * @param edge a String[] with the two labels.
   */
  public void removeHighlightedEdge(String[] edge) {
    Vector v = new Vector(2);
    v.add(edge[0]);
    v.add(edge[1]);
    latdrawwin.removeHighlightedEdge(v);
  }

  /**
   * Remove an edge to the highlighted edges. 
   * @param edge a vector with the two String labels.
   */
  public void removeHighlightedEdge(Vector edge) {
    latdrawwin.removeHighlightedEdge(edge);
  }

  /**
   * Remove all edges from the highlighted edges. 
   */
  public void clearHighlightedEdges() {
    latdrawwin.clearHighlightedEdges();
  }

  /**
   * Add an element to the filled vertices and give it a color.
   */
  public void addColoredElement(String elemLabel, Color color) {
    latdrawwin.addFilledVertex(elemLabel, color);
  }

  /**
   * Remove an element to the filled vertices and give it a color.
   */
  public void removeColoredElement(String elemLabel) {
    latdrawwin.removeFilledVertex(elemLabel);
  }

  /**
   * Clear the filled vertices.
   */
  public void clearColoredElements() {
    latdrawwin.clearFilledVertices();
  }


  /**
   * Add an element to the filled vertices and give it a color.
   */
  public void addBorderColoredElement(String elemLabel, 
                                      Color color, boolean thick) {
    latdrawwin.addDrawnVertex(elemLabel, color, thick);
  }

  /**
   * Remove an element to the filled vertices and give it a color.
   */
  public void removeBorderColoredElement(String elemLabel) {
    latdrawwin.removeDrawnVertex(elemLabel);
  }

  /**
   * Clear the filled vertices.
   */
  public void clearBorderColoredElements() {
    latdrawwin.clearDrawnVertices();
  }

}

