package uacalc.util;

//Maybe this shuold be a subclass of java.io.File

/**
 * Handles file name extensions.
 * For convenience, the methods are static.
 */

public class FileNameExtension {

    /**
     * Returns the extension of FileName, or null.
     */
    public static String getExtension(String FileName) {
	int i = FileName.lastIndexOf(ExtensionSeparator);
	if(i>0 && i<FileName.length()-1) {
	    return FileName.substring(i+1).toLowerCase();
	}; 
	return(null);
    }

    /**
     * Returns FileName.Extension
     */
    public static String appendExtension(String FileName, String Extension) {
	if(Extension == null || Extension.length() == 0) return(FileName);
	return(FileName + ExtensionSeparator + Extension);
    }

    /**
     * Returns FileName without the extension.
     */
    public static String stripExtension(String FileName) {
	int i = FileName.lastIndexOf(ExtensionSeparator);
	if( i == -1 ) return(FileName);
	return FileName.substring(0,i);
    }

    public static final String ExtensionSeparator = ".";
}
