package uacalc.util;

import java.io.File;
import javax.swing.filechooser.FileFilter;


/**
 * A simple file filter that accepts directories,
 * and only one extension type.
 */
public class SimpleFileFilter extends FileFilter{

    public SimpleFileFilter(String extension, String description) {
	m_extension = extension;
	m_description = description;
    }

    public boolean accept(File f) {
        if(f != null) {
            if(f.isDirectory()) {
                return true;
            }
            String extension = FileNameExtension.getExtension(f.getName());
            if(extension != null && 
	       extension.equals(m_extension) ) {
		return true;
            }
        }
        return false;
    }

    public String getDescription() {
        return m_description;
    }

    public String getExtension() {
        return m_extension;
    }

    private String m_extension;
    private String m_description;

}

