package uacalc.vectors;

import java.math.*;
import java.util.*;

import uacalc.ex.BadVectorListException;


public class FreeVectorList extends VectorList {

    public FreeVectorList(int size, int rank) 
	throws BadVectorListException {

	BigInteger bigPow = 
	    (BigInteger.valueOf( (long)size )).pow(rank);
	if( bigPow.compareTo((BigInteger.valueOf(
	    (long)VEC_LEN_LIMIT )) ) >= 0 )  {
	    throw new BadVectorListException(
		"Cannot create the generators of a free algebra:\n" +
		"size^rank should be at most" + (VEC_LEN_LIMIT-1) + ".");
	}

	m_length = bigPow.intValue();

	
	int i, j, element, k, n;
	int chunks = m_length/size;
	int repeats = 1;

	for(i = 0; i < rank; i++ ) {
	    int[] v = new int[m_length];
	    n=0;
	    for( j = 0; j < repeats; j++) {
		for( element = 0; element < size; element++) {
		    for( k=0; k < chunks; k++) {
			v[n]=element;
			n++;
		    }
		}

	    }
	    chunks /= size;
	    repeats *= size;
	    add(v);
	}
    }

}

